From bf566fdffb1471c99b6f3c9c1833f0399aca2313 Mon Sep 17 00:00:00 2001
From: Matheus Alcantara <mths.dev@pm.me>
Date: Thu, 26 Jun 2025 12:05:28 -0300
Subject: [PATCH v1] docs: add note of SCRAM pass-through for bgworkers

---
 doc/src/sgml/postgres-fdw.sgml | 8 ++++++++
 1 file changed, 8 insertions(+)

diff --git a/doc/src/sgml/postgres-fdw.sgml b/doc/src/sgml/postgres-fdw.sgml
index 781a01067f7..8d36056f72d 100644
--- a/doc/src/sgml/postgres-fdw.sgml
+++ b/doc/src/sgml/postgres-fdw.sgml
@@ -834,6 +834,14 @@ OPTIONS (ADD password_required 'false');
          </listitem>
         </itemizedlist>
        </para>
+
+      <note>
+       <para>
+        For extension developers, background workers that use foreign tables is
+        unable to scram pass-through, so for these scenarios, the password is
+        required on USER MAPPING options.
+       </para>
+      </note>
       </listitem>
      </varlistentry>
 
-- 
2.39.5 (Apple Git-154)